-- fichier p_e_sortie.adb
-- D.F. juillet 2002 (accents sous NT grs, Unbounded lus)

with Ada.Command_Line;              use Ada.Command_Line;
with Ada.Strings.Fixed;             use Ada.Strings.Fixed;
with Ada.Strings.Maps.Constants;    use Ada.Strings.Maps.Constants;
with Ada.Strings.Unbounded.Text_Io; use Ada.Strings.Unbounded.Text_Io;

package body P_E_Sortie is

   Dos : Boolean;  

   package Reel_Io is new Float_Io(Float);

   -- deux fonctions de conversion des caractres accentus

   function Dos_To_Iso (
         Carac : in     Character ) 
     return Character; 

   function Iso_To_Dos (
         Carac : in     Character ) 
     return Character; 

   -- *********************************

   function Image (
         Le_Reel : in     Float ) 
     return String is 
      S : String (1 .. 80) := (others => '0');  
      L : Natural          := S'Length;  
      I : Natural          := L;  

   begin
      Reel_Io.Put(S(1..L),Le_Reel,Exp=>0);
      for J in reverse 1..L
            loop
         exit when (S(J) /= '0');
         I := I - 1;
      end loop;
      if S(I) = '.' then
         I := I + 1;
      end if;
      L := I;
      I := 0;
      for J in 1..L
            loop
         I := I + 1;
         exit when S(J) /= ' ';
      end loop;
      return S(I..L);
   end Image;

   function Image (
         L_Entier : in     Integer ) 
     return String is 
   begin
      return Integer'Image(L_Entier);
      -- homognit avec IMAGE d'un FLOAT
   end Image;


   procedure Ecrire (
         Le_Reel : in     Float ) is 
   begin
      Put(Image(Le_Reel));
   end Ecrire;

   procedure Ecrire (
         L_Entier : in     Integer ) is --  vite INTEGER_IO
   begin
      Put(Integer'Image(L_Entier));
   end Ecrire;

   procedure Lire (
         Le_Reel :    out Float ) is 
   begin
      loop
         begin
            Reel_Io.Get(Le_Reel);
            Skip_Line;
            exit;
         exception
            when others =>
               Skip_Line; -- vide le tampon
               Put_Line("saisie non valable recommencez");
         end;
      end loop;
   end Lire;

   procedure Lire (
         L_Entier :    out Integer ) is 
      -- ressemble  la lecture d'un type discret! bonne application
   begin
      loop
         declare
            Reponse : String (1 .. Integer'Width + 1);  
            -- +1 pour le signe! 
         begin
            Lire(Reponse);
            L_Entier := Integer'Value(Reponse);
            exit;
         exception
            when others =>
               Put_Line("saisie non valable recommencez");
         end;
      end loop;
   end Lire;

   procedure Vider_Tampon is 
   begin
      Skip_Line(1);
   end Vider_Tampon;

   procedure Lire (
         La_Chaine :    out String ) is -- out car tout est modifi
   begin
      loop
         declare
            S : String (1 .. La_Chaine'Length + 1) := (others => ' ');  
            L : Natural;  
         begin
            Get_Line(S,L);
            if (L = S'Length)
                  then
               Skip_Line;
               Put_Line("saisie trop longue recommencez");
            else
               for Ind in La_Chaine'range
                     loop
                  if Dos then
                     La_Chaine(Ind) := Dos_To_Iso(S(Ind));
                  else
                     La_Chaine(Ind) := S(Ind);
                  end if;
               end loop;
               exit;
            end if;
         exception  --  titre de prcaution
            when others =>
               Put_Line("probleme recommencez");
         end;
      end loop;
   end Lire;

   procedure Lire (
         La_Chaine :    out Unbounded_String ) is 
   begin
        La_Chaine := Get_Line;
   end Lire;

   procedure Lire (
         Carac :    out Character ) is 
   begin
      Get(Carac);
      if Dos then
         Carac := Dos_To_Iso (Carac);
      end if;
      Skip_Line;
   end Lire;

   procedure Ecrire (
         Carac : Character ) is 
   begin
      if Dos then
         Put(Iso_To_Dos (Carac));
      else
         Put(Carac);
      end if;
   end Ecrire;

   procedure Ecrire (
         La_Chaine : String ) is 
   begin
      for Ind in La_Chaine'range
            loop
         if Dos then
            Put(Iso_To_Dos (La_Chaine(Ind)));
         else
            Put(La_Chaine(Ind));
         end if;
      end loop;
   end Ecrire;

   procedure Pause is 
   begin
      Put(Standard_Error,
         "appuyez sur Entree pour continuer");
      Skip_Line;
   end Pause;

   -- sous programmes locaux on peut ajouter ses caractres
   
   function Iso_To_Dos (
         Carac : in     Character ) 
     return Character is 
   begin
      case Character'Pos(Carac) is
         when 224 =>
            return Character'Val(133); --
         when 226 =>
            return Character'Val(131); --
         when 228 =>
            return Character'Val(132); --
         when 231 =>
            return Character'Val(135); --
         when 232 =>
            return Character'Val(138); --
         when 233 =>
            return Character'Val(130); --
         when 234 =>
            return Character'Val(136); --
         when 235 =>
            return Character'Val(137); --
         when 238 =>
            return Character'Val(140); --
         when 239 =>
            return Character'Val(139); --
         when 244 =>
            return Character'Val(147); --
         when 246 =>
            return Character'Val(148); --
         when 249 =>
            return Character'Val(151); --
         when 251 =>
            return Character'Val(150); --
         when 252 =>
            return Character'Val(129); --
         when others =>
            return Carac;
      end case;
   end Iso_To_Dos;

   function Dos_To_Iso (
         Carac : in     Character ) 
     return Character is 
   begin
      case Character'Pos(Carac) is
         when 129 =>
            return Character'Val(252); --
         when 130 =>
            return Character'Val(233); --
         when 131 =>
            return Character'Val(226); --
         when 132 =>
            return Character'Val(228); --
         when 133 =>
            return Character'Val(224); --
         when 135 =>
            return Character'Val(231); --
         when 136 =>
            return Character'Val(234); --
         when 137 =>
            return Character'Val(235); --
         when 138 =>
            return Character'Val(232); --
         when 139 =>
            return Character'Val(239); --
         when 140 =>
            return Character'Val(238); --
         when 147 =>
            return Character'Val(244); --
         when 148 =>
            return Character'Val(246); --
         when 150 =>
            return Character'Val(251); --
         when 151 =>
            return Character'Val(249); --
         when others =>
            return Carac;
      end case;
   end Dos_To_Iso;


begin

   Dos := Argument_Count = 1 and then
      Translate (Argument (1), Upper_Case_Map) = "DOS";

end P_E_Sortie;