-- fichier p_moucheron-eve-moucheron8.adb 
-- D.Feneuille janvier 2004
-- pour TP 8 (2 heures seulement avec le TP 6_7)
-- Etude des codages Ada des algos vus en TDs
-- Partir du fichier p_moucheron-eve-moucheron8.squ

with Ada.Characters.Handling;
use Ada.Characters.Handling;

package body P_Moucheron.Eve.Moucheron8 is

   -- crire ici le dtail des commandes de la machine 
   -- soit les trois versions de PALINDROMES (V1, V2 et V3)

   -- dclaration types et constante :

   Max_Long : constant := 20;  
   type T_Mots is array (Positive range <>) of Character; 

   subtype T_Long is Positive range 1 .. Max_Long;
   subtype T_Les_Mots is T_Mots (T_Long);

   Motsuiv : T_Les_Mots;  
   Miroir  : T_Les_Mots;  

   Long_Motsuiv : T_Long;  

   -- dclaration des modules "primitives"
   procedure Sauter_Les_Blancs; 
   procedure Mot_Suivant; 
   procedure Mot_Miroir; -- pour version 1
   procedure Comparer_Palin; -- alias TRAITER_MOT pour V1
   procedure Comparer_Direct_Palin; -- pour V2  faire
   procedure Comparer_Direct_Mamie; -- pour V3

   -- dclaration et dfinition des procdures principales

   procedure Palin_V1 (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

      --  faire en TP
   begin
      Compteur := 0;
      Carcou := ' ';
      loop
         exit when Fin_Ruban;
         Sauter_Les_Blancs;
         exit when Carcou = ' ';
         Mot_Suivant;
         Comparer_Palin;
      end loop;
      Ecrire ("Nombre de mots palindrome version 1   ");
      Ecrire_Compteur;
      A_La_Ligne;
   end Palin_V1;

   procedure Palin_V2 (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

   begin
      Compteur := 0;
      Carcou := ' ';
      loop
         exit when Fin_Ruban;
         Sauter_Les_Blancs;
         exit when Carcou = ' ';
         Mot_Suivant;
         Comparer_Direct_Palin;
      end loop;
      Ecrire ("Nombre de mots palindrome version 2   ");
      Ecrire_Compteur;
      A_La_Ligne;
   end Palin_V2;

   procedure Palin_V3 (
         Button : access Gtk.Button.Gtk_Button_Record'Class ) is 
      pragma Unreferenced (Button);

      -- version de mamie!!
   begin
      Compteur := 0;
      Carcou := ' ';
      loop
         exit when Fin_Ruban;
         Sauter_Les_Blancs;
         exit when Carcou = ' ';
         Mot_Suivant;
         Comparer_Direct_Mamie;
      end loop;
      Ecrire ("Nombre de mots palindrome version 3   ");
      Ecrire_Compteur;
      A_La_Ligne;
   end Palin_V3;

   -- dfinition des "primitives"

   procedure Sauter_Les_Blancs is 
   begin
      loop
         exit when (Carcou /= ' ') or Fin_Ruban;
         Lire;
      end loop;
   end Sauter_Les_Blancs;

   procedure Mot_Suivant is 
      Ind : T_Long := 1;  
   begin -- MOT_SUIVANT
      Motsuiv (Ind) := To_Upper(To_Basic(Carcou));
      loop
         exit when Fin_Ruban;
         Lire;
         exit when Carcou = ' ';
         Ind := Ind + 1;
         Motsuiv (Ind) := To_Upper(To_Basic(Carcou));
      end loop;
      Long_Motsuiv := Ind;
   end Mot_Suivant;

   procedure Mot_Miroir is 
      Inf : T_Long := 1;  
      Sup : T_Long := Long_Motsuiv;  
   begin
      loop
         Miroir (Inf) := Motsuiv (Sup);
         exit when Sup = 1;
         Inf := Inf + 1;
         Sup := Sup - 1;
      end loop;
   end Mot_Miroir;

   procedure Comparer_Palin is -- pour version 1
      Ind : T_Long;  
   begin
      Mot_Miroir;
      -- on rutilise COMPARER du TD 6
      Ind := 1;
      loop
         exit when (Miroir (Ind) /= Motsuiv (Ind)) or (Ind = Long_Motsuiv);
         Ind := Ind  +  1;
      end loop;
      if (Miroir (Ind) = Motsuiv (Ind))
            then
         Compteur := Compteur + 1;
      end if;
   end Comparer_Palin;

   procedure Comparer_Direct_Palin is -- pour version 2  faire
      Deb : T_Long := 1;  
      Fin : T_Long := Long_Motsuiv;  
   begin
      loop
         exit when (Motsuiv (Fin) /= Motsuiv (Deb)) or (Deb >=Fin) ;
         Deb := Deb  +  1;
         Fin := Fin - 1;
      end loop;
      -- tude des conditions de sortie!!
      -- (MOTSUIV (FIN) /= MOTSUIV (DEB)) et (DEB >=FIN)
      -- erreur juste au milieu
      -- (MOTSUIV (FIN) /= MOTSUIV (DEB)) et (DEB < FIN)
      -- erreur dans le mot avant le croisement
      -- (MOTSUIV (FIN) = MOTSUIV (DEB)) et (DEB >=FIN)
      -- cas intressant
      if (Motsuiv (Fin) = Motsuiv (Deb))
            then
         Compteur := Compteur + 1;
      end if;
   end Comparer_Direct_Palin;

   procedure Comparer_Direct_Mamie is  -- pour version 3
      Ind    : T_Long  := 1;  
      Sortie : Boolean := False;  
   begin
      loop
         exit when (Ind > Long_Motsuiv/2) or Sortie;
         if (Motsuiv(Ind) = Motsuiv(Long_Motsuiv - Ind + 1))
               then
            Ind := Ind  +  1;
         else
            Sortie := True;
         end if;
      end loop;
      -- (IND > LONG_MOTSUIV/2) and SORTIE (cas imposssible!)
      -- (IND > LONG_MOTSUIV/2) and not SORTIE
      -- (IND <= LONG_MOTSUIV/2) and SORTIE
      if not Sortie
            then
         Compteur := Compteur + 1;
      end if;
   end Comparer_Direct_Mamie;

end P_Moucheron.Eve.Moucheron8;